//   Soutn slo    16

unit s16_Unit_2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,s16_promene,s16_unit3;

Const Pcolor: array[1..2] of longint = ( clBLUE, clRED );   // Kad hr m svoji barvu zpalek
Const DarkPcolor: array[1..2] of longint = ( clAQUA, clFUCHSIA );   // Kad hr m svoji barvu tverce

type
  TPlocha = class(TForm)
    Pole: TImage;
    Button1: TButton;
    Pan_ovladani: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    PlayerIndicator: TLabel;
    Obnovovac: TTimer;
    ScoreBoard: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    Score1: TLabel;
    Score2: TLabel;
    ScoreLabel: TLabel;
    TopTENbutton: TButton;
    procedure PoleMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PoleCreate;
    procedure Button1Click(Sender: TObject);
    procedure Button1KeyPress(Sender: TObject; var Key: Char);
    procedure ShowHORs(nx,ny: byte);  // Zobraz horizontln ipku
    procedure HideHORs(nx,ny: byte);  // Skryj horizontln ipku
    procedure ShowVERs(nx,ny: byte);  // Zobraz vertikln ipku
    procedure HideVERs(nx,ny: byte);  // Skryj vertikln ipku
    procedure VykresliSirku(px,py:byte;Sm: Tsmer);
    procedure ObnovovacTimer(Sender: TObject);  // Vykresl sirku a provede pravy ohledn zmny hre atd.
    procedure TestHOR(Px,Py: byte);     // Kontrola zda-li jsou poloeny vechny sirky do tverce
    procedure TestVER(Px,Py: byte);     // Kontrola zda-li jsou poloeny vechny sirky do tverce
    procedure TestEND;
    procedure LoadTopTEN;
    procedure saveTopTEN;
    procedure TopTENbuttonClick(Sender: TObject);
    procedure KonecHry;

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Plocha: TPlocha;

implementation



{$R *.DFM}
var Ft: TextFile;    // oteven textovho souboru TOP.TEN
    s1: string;      // promnn pro ten ze souboru
    b1: Word;        // promnn pro ten ze souboru


procedure Tplocha.LoadTopTEN;
var n: byte; // pro cyklus
 begin
   {$I-}
    AssignFile(ft,'TOP.TEN');
     Reset(ft);
     score.scoreTable.lines.clear;
     for n:=1 to 10 do
      begin
        Readln(ft,b1);
        Readln(ft,s1);
        tten[n].name:=s1;
        tten[n].bodu:=b1;
        with score.scoretable do
          begin
            lines.add(inttostr(n)+'  '+inttostr(b1)+'    '+s1);
          end;

      end;
     CloseFile(ft);
   {$I+}
   if IOResult<>0 then
     Begin
       ShowMessage('Chyba pi otevrn souboru TOP.TEN');
       Ukonci:=true;
     end;
 end;

 procedure Tplocha.SaveTopTEN;
var n: byte; // pro cyklus
 begin
   {$I-}
    AssignFile(ft,'TOP.TEN');
     Rewrite(ft);
     for n:=1 to 10 do
      begin
        s1:=tten[n].name;
        b1:=tten[n].bodu;
        Writeln(ft,b1);
        Writeln(ft,s1);
      end;
     CloseFile(ft);
   {$I+}
   if IOResult<>0 then
     Begin
       ShowMessage('Chyba pi zpisu souboru TOP.TEN');
       Ukonci:=true;
     end;
 end;


procedure Tplocha.TestEND;
 var Nx,Ny: Byte;  // Promnn pro kontrolu celho obsahu st
     JeEND: boolean;  // Konec Hry?
 begin
  JeEND:=True;
  For Nx:=0 to roz do
    For Ny:=0 to roz-1 do
      begin
        if not VERsirky[nx,ny] then jeEND:=false;
        if not HORsirky[ny,nx] then JeEND:=false;
      end;
   if JeEND then konecHry;
 end;  // END OF PROC


procedure Tplocha.TestHOR(Px,Py: byte);
 var provedeno: boolean;  // Bylo dosaeno bodu?
 begin
  provedeno:=False;
   If HORsirky[px,py-1]
     then
        If (VERsirky[px,py-1]) and (VERsirky[Px+1,Py-1]) then
         begin Bodu[Hrac]:=bodu[hrac]+1;Provedeno:=true;
          with pole.Canvas do
           begin
            pen.color:=DarkPcolor[hrac];
            rectangle(px*30-1,py*30+2,(px+1)*30+2,(py-1)*30-1);
            rectangle(px*30,py*30+1,(px+1)*30+1,(py-1)*30);
           end;
         end;
   If HORsirky[px,py+1]
     then
        If (VERsirky[px,py]) and (VERsirky[Px+1,Py]) then
         begin Bodu[Hrac]:=bodu[hrac]+1;Provedeno:=true;
          with pole.Canvas do
           begin
            pen.color:=DarkPcolor[hrac];
            rectangle(px*30-1,py*30,(px+1)*30+2,(py+1)*30+2);
            rectangle(px*30,py*30+1,(px+1)*30+1,(py+1)*30+1);
           end;
         end;
  if provedeno then Case hrac of 1: hrac:=2;2: hrac:=1;end;
 end;  // END OF PROC

procedure Tplocha.TestVER(Px,Py: byte);
 var provedeno: boolean;  // Bylo dosaeno bodu?
 begin
  provedeno:=False;
   If VERsirky[px-1,py]
     then
        If (HORsirky[px-1,py]) and (HORsirky[Px-1,Py+1]) then
         begin Bodu[Hrac]:=bodu[hrac]+1;Provedeno:=true;
          with pole.Canvas do
           begin
            pen.color:=DarkPcolor[hrac];
            px:=px-1;
            rectangle(px*30-1,py*30,(px+1)*30+2,(py+1)*30+2);
            rectangle(px*30,py*30+1,(px+1)*30+1,(py+1)*30+1);
           end;
         end;
   If VERsirky[px+1,py]
     then
        If (HORsirky[px,py]) and (HORsirky[Px,Py+1]) then
         begin Bodu[Hrac]:=bodu[hrac]+1;Provedeno:=true;
          with pole.Canvas do
           begin
            pen.color:=DarkPcolor[hrac];
            rectangle(px*30-1,py*30,(px+1)*30+2,(py+1)*30+2);
            rectangle(px*30,py*30+1,(px+1)*30+1,(py+1)*30+1);
           end;
         end;
  if provedeno then Case hrac of 1: hrac:=2;2: hrac:=1;end;
end;  // END OF PROC

procedure Tplocha.VykresliSirku(px,py:byte;Sm: Tsmer);
var provedeno: boolean;  // Byla sirka poloena?
begin
Provedeno:=false;
// Horizontln
if (sm=Horiz)and(not HORsirky[px,py]) then
  With pole.canvas do
    begin
      HORsirky[px,py]:=TRUE;
      pen.color:=Pcolor[hrac];
      Moveto(Px*30,Py*30+1);
      Lineto(Px*30+29,Py*30+1);
      Moveto(Px*30,Py*30);
      Lineto(Px*30+29,Py*30);
      Provedeno:=true;
      TestHOR(px,py);
      end;
// Vertikln
if (sm=vert)and(not VERsirky[px,py]) then
  With pole.canvas do
    begin
      VERsirky[px,py]:=TRUE;
      pen.color:=Pcolor[hrac];
      Moveto(Px*30+1,Py*30);
      Lineto(Px*30+1,Py*30+29);
      Moveto(Px*30,Py*30);
      Lineto(Px*30,Py*30+29);
      Provedeno:=true;
      TestVER(px,py);
    end;
// Zmn hre
if provedeno then
  Case hrac of
    1: hrac:=2;
    2: hrac:=1;
   end;
TestEND;
end;  // END OF PROC

procedure TPlocha.PoleCreate;
var Nx,Ny: byte;   // Rozmer X, Rozmer Y ( pro cykly )
    Rx,Ry: ShortInt;  //  Promn pro Cykly
begin
  // <Nastaven nkterch parametr startu hry>
  Smer:=Horiz;
  Hrac:=2;
  Pozx:=0;
  pozy:=0;
  For rx:=-1 to 11 do
    For ry:=-1 to 10 do
     begin
       HORsirky[ry,rx]:=False;
       Versirky[rx,ry]:=False;
     end;
   LoadTopTEn;
 // </Nastaven nkterch parametr startu hry>


  Pole.Canvas.Pen.color:=clBlack;
  Pole.Canvas.Rectangle(0,0,roz*30+1,roz*30+1);   // Obrys hrac plochy
  For Nx:=0 to roz-1 do
    For Ny:=0 to roz-1 do
       With pole.canvas do
          Begin
            Moveto(nx*30,ny*30);       //  Horiz
            Lineto(nx*30+29,ny*30);    //       ontln
            Moveto(nx*30,ny*30);       //  Verti
            Lineto(nx*30,ny*30+29);    //       kln
          End;
end;   // END OF PROC

procedure TPlocha.Button1Click(Sender: TObject);
begin
Ukonci:=true;
end;  // END OF PROC



procedure TPlocha.PoleMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Nx,Ny: word;   // Rozmer X, Rozmer Y ( pro cykly )
    Px,Py: byte;   // Pomocn X, Y  ( Mezizachovn vsledku )
begin
// Byla klepnuta Horizontln sirka
For Ny:=0 to Roz do
  Begin
    If ((y=(ny*30))or(y=(ny*30+1))or(y=(ny*30+2))or(y=(ny*30-1))or(y=(ny*30-2))) and (x<=roz*30)then
      Begin
        // Vykresli sirku
         Px:=X div 30;
         Py:=Ny;
         VykresliSirku(px,py,horiz);
       end;
   end;

// Byla klepnuta Vertikln sirka
For Nx:=0 to Roz do
  Begin
    If ((x=(nx*30))or(x=(nx*30+1))or(x=(nx*30+2))or(x=(nx*30-1))or(x=(nx*30-2))) and (y<=roz*30)then
      Begin
        // Vykresli sirku
         Px:=Nx;
         Py:=Y div 30;
         VykresliSirku(px,py,vert);
      end;
  end;

end;  // END OF PROC

procedure Tplocha.ShowHORs(nx,ny: byte);  // Zobraz horizontln ipku
  begin
    with Pole.Canvas do
     begin
       pen.color:=ClBLACK;
       Moveto(nx*30+15,ny*30+5);
       Lineto(nx*30+15,ny*30+15);
       Moveto(nx*30+15,ny*30+5);
       Lineto(nx*30+10,ny*30+10);
       Moveto(nx*30+15,ny*30+5);
       Lineto(nx*30+20,ny*30+10);
     end;
  end;  // END OF PROC

procedure Tplocha.HideHORs(nx,ny: byte);  // Zobraz horizontln ipku
  begin
    with Pole.Canvas do
     begin
       Pen.color:=clWhite;
       Moveto(nx*30+15,ny*30+5);
       Lineto(nx*30+15,ny*30+15);
       Moveto(nx*30+15,ny*30+5);
       Lineto(nx*30+10,ny*30+10);
       Moveto(nx*30+15,ny*30+5);
       Lineto(nx*30+20,ny*30+10);
     end;
  end;   // END OF PROC

procedure Tplocha.ShowVERs(nx,ny: byte);  // Zobraz horizontln ipku
  begin
    with Pole.Canvas do
     begin
       pen.color:=ClBLACK;
       Moveto(nx*30+5,ny*30+15);
       Lineto(nx*30+15,ny*30+15);
       Moveto(nx*30+5,ny*30+15);
       Lineto(nx*30+10,ny*30+10);
       Moveto(nx*30+5,ny*30+15);
       Lineto(nx*30+20,ny*30+10);
     end;
  end;  // END OF PROC

procedure Tplocha.HideVERs(nx,ny: byte);  // Zobraz horizontln ipku
  begin
    with Pole.Canvas do
     begin
       Pen.color:=clWhite;
       Moveto(nx*30+5,ny*30+15);
       Lineto(nx*30+15,ny*30+15);
       Moveto(nx*30+5,ny*30+15);
       Lineto(nx*30+10,ny*30+10);
       Moveto(nx*30+5,ny*30+15);
       Lineto(nx*30+20,ny*30+10);
     end;
  end;   // END OF PROC

procedure TPlocha.Button1KeyPress(Sender: TObject; var Key: Char);
 begin


  if smer=horiz then HideHORs(pozx,pozy);
  if smer=vert  then HideVERs(pozx,pozy);

  Case key of
    '8': if pozy>0 then pozy:=pozy-1;
    '2': begin
           if (pozy<roz) and (smer=horiz) then pozy:=pozy+1;
           if (pozy<roz-1 ) and (smer=vert) then pozy:=pozy+1;
          end;
    '4': if pozx>0 then pozx:=pozx-1;
    '6': begin
           if (pozx<roz-1) and (smer=horiz) then pozx:=pozx+1;
           if (pozx<roz) and (smer=vert) then pozx:=pozx+1;
          end;
    '7': VykresliSirku(pozx,pozy,smer);
    '0': case smer of
             vert: smer:=horiz;
             Horiz: smer:=vert;
            end;
  end;

  if smer=horiz then showHORs(pozx,pozy);
  if smer=vert  then showVERs(pozx,pozy);

end;    // END OF PROC

procedure TPlocha.ObnovovacTimer(Sender: TObject);
// Mon vm pijde tahle procedure zbyten, zmnu hre
// bych mohl eit v nap. v procedue VykresliSirku, ale
// takto se vyhnu problikvn formu. M osobn se to tak
// prost lb vc. Dkuji za pochopen.
begin
 if playerIndicator.caption<>PLIndicator[hrac] then PlayerIndicator.caption:=PLIndicator[hrac];
 If Score1.caption<>IntToStr(bodu[1]) then Score1.caption:=IntTostr(bodu[1]);
 If Score2.caption<>IntToStr(bodu[2]) then Score2.caption:=IntTostr(bodu[2]);
end;  // END OF PROC


procedure TPlocha.TopTENbuttonClick(Sender: TObject);
begin
  Score.visible:=true;
end;

procedure Tplocha.KonecHry;
var n:byte;   // pro cyklus
  begin
   // Vsledky prvnho hre
    for n:=1 to 11 do
     if tten[n].bodu<bodu[1] then break;
   if n<>0 then begin tten[n].bodu:=bodu[1];tten[n].name:=Jmh1;end;
   // Vsledky druhho hre
    for n:=1 to 11 do
     if tten[n].bodu<bodu[2] then break;
   if n<>0 then begin tten[n].bodu:=bodu[2];tten[n].name:=Jmh2;end;

   saveTOPTEN;
   ShowMessage('KONEC HRY');
   close;
   Objev:=true;
  end;

  end.
